/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "AllocUtils.h"

int *
oneDDoubleDAlloc_int (unsigned int line)
{
  int *vector;

  vector = (int *) calloc (line, sizeof (int));

  return vector;
}

float *
oneDFloatDAlloc (unsigned int line)
{
  float *vector;

  vector = (float *) calloc (line, sizeof (float));

  return vector;
}

double *
oneDDoubleDAlloc (unsigned int line)
{
  double *vector;

  vector = (double *) calloc (line, sizeof (double));

  return vector;
}

char *
oneDCharDAlloc (unsigned int line)
{
  char *res;

  res = (char *) calloc (line, sizeof (char));

  return res;
}

FILE **
oneDpFileDAlloc (unsigned int line)
{
  FILE **vector;

  vector = (FILE **) calloc (line, sizeof (FILE *));

  return vector;
}

int **
twoDIntDAlloc (unsigned int line, unsigned int column)
{
  unsigned int i;
  int **board;

  board = (int **) calloc (line, sizeof (int *));

  for (i = 0; i <= line - 1; i++)
    board[i] = (int *) calloc (column, sizeof (int));

  return board;
}

float **
twoDFloatDAlloc (unsigned int line, unsigned int column)
{
  unsigned int i;
  float **board;

  board = (float **) calloc (line, sizeof (float *));

  for (i = 0; i <= line - 1; i++)
    board[i] = (float *) calloc (column, sizeof (float));

  return board;
}

double **
twoDDoubleDAlloc (unsigned int line, unsigned int column)
{
  unsigned int i;
  double **board;

  board = (double **) calloc (line, sizeof (double *));

  for (i = 0; i <= line - 1; i++)
    board[i] = (double *) calloc (column, sizeof (double));

  return board;
}

char **
twoDCharDAlloc (unsigned int line, unsigned int column)
{
  unsigned int i;
  char **board;

  board = (char **) calloc (line, sizeof (char *));

  for (i = 0; i <= line - 1; i++)
    board[i] = (char *) calloc (column, sizeof (char));

  return board;
}

int ***
threeDIntDAlloc (unsigned int line, unsigned int column, unsigned int depth)
{
  unsigned int i, j;
  int ***board;

  board = (int ***) calloc (line, sizeof (int **));

  for (i = 0; i <= line - 1; i++)
  {
    board[i] = (int **) calloc (column, sizeof (int *));
    for (j = 0; j <= column - 1; j++)
      board[i][j] = (int *) calloc (depth, sizeof (int));
  }

  return board;
}

double ***
threeDDoubleDAlloc (unsigned int line, unsigned int column,
		    unsigned int depth)
{
  unsigned int i, j;
  double ***board;

  board = (double ***) calloc (line, sizeof (double **));

  for (i = 0; i <= line - 1; i++)
  {
    board[i] = (double **) calloc (column, sizeof (double *));
    for (j = 0; j <= column - 1; j++)
      board[i][j] = (double *) calloc (depth, sizeof (double));
  }

  return board;
}

char ***
threeDCharDAlloc (unsigned int line, unsigned int column, unsigned int depth)
{
  unsigned int i, j;
  char ***board;

  board = (char ***) calloc (line, sizeof (char **));

  for (i = 0; i <= line - 1; i++)
  {
    board[i] = (char **) calloc (column, sizeof (char *));
    for (j = 0; j <= column - 1; j++)
      board[i][j] = (char *) calloc (depth, sizeof (char));
  }

  return board;
}

int **
oneDpIntDAlloc (unsigned int line)
{
  int **vector;

  vector = (int **) calloc (line, sizeof (int *));

  return vector;
}

double **
oneDpDoubleDAlloc (unsigned int line)
{
  double **vector;

  vector = (double **) calloc (line, sizeof (double *));

  return vector;
}

int ***
oneDppIntDAlloc (unsigned int line)
{
  int ***vector;

  vector = (int ***) calloc (line, sizeof (int **));

  return vector;
}

double ***
oneDppDoubleDAlloc (unsigned int line)
{
  double ***vector;

  vector = (double ***) calloc (line, sizeof (double **));

  return vector;
}
