/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "FreeUtils.h"

void
oneDIntFree (int *res)
{
  free (res);

  return;
}

void
oneDFloatFree (float *res)
{
  free (res);

  return;
}

void
oneDDoubleFree (double *res)
{
  free (res);

  return;
}

void
twoDIntFree (int **board, unsigned int line)
{
  int i;

  for (i = line - 1; i >= 0; i--)
    free (board[i]);

  free (board);

  return;
}

void
twoDFloatFree (float **board, unsigned int line)
{
  int i;

  for (i = line - 1; i >= 0; i--)
    free (board[i]);

  free (board);

  return;
}

void
twoDDoubleFree (double **board, unsigned int line)
{
  int i;

  for (i = line - 1; i >= 0; i--)
    free (board[i]);

  free (board);

  return;
}

void
threeDIntFree (int ***board, unsigned int line, unsigned int column)
{
  int i, j;

  for (i = line - 1; i >= 0; i--)
    for (j = column - 1; j >= 0; j--)
      free (board[i][j]);

  for (i = line - 1; i >= 0; i--)
    free (board[i]);

  free (board);

  return;
}


void
oneDCharFree (char *string)
{
  free (string);

  return;
}

void
twoDCharFree (char **board, unsigned int line)
{
  int i;

  for (i = line - 1; i >= 0; i--)
    free (board[i]);

  free (board);

  return;
}

extern void
oneDpFileFree (FILE ** files)
{
  free (files);

  return;
}
