#include "PrintGeoAsX.h"

void
PrintGeoFaceToPlot (struct GEO Geo, int *faces, int *FaceList)
{
  int i, j;

  /* recording faces to plot */
  for (i = 1; i <= Geo.FaceQty; i++)
    if (Geo.FaceState[i] >= 0)
    {
      for (j = 0; j < 2; j++)
	if (Geo.FaceGerm[i][j] < 0)
	{
	  if (oneDIntEltPos (faces, 1, faces[0],
			     -Geo.FaceGerm[i][j], 0) != -1)
	  {
	    FaceList[0]++;
	    FaceList[FaceList[0]] = i;
	  }
	  break;
	}
    }

  return;
}


void
PrintGeoEdgeToPlot (struct GEO Geo, int *FaceList, int *EdgeList)
{
  int i, j, face, edge;

  /* recording vertices and edges to plot */
  for (i = 1; i <= FaceList[0]; i++)
  {
    face = FaceList[i];

    for (j = 1; j <= Geo.FaceVerQty[face]; j++)
    {
      edge = Geo.FaceEdgeNb[face][j];
      if (oneDIntEltPos (EdgeList, 1, EdgeList[0], edge, 0) == -1)
      {
	EdgeList[0]++;
	EdgeList[EdgeList[0]] = edge;
      }
    }
  }

  return;
}

void
PrintGeoVerToPlot (struct GEO Geo, int *FaceList, int *VerList)
{
  int i, j, face, ver;

  /* recording vertices and edges to plot */
  for (i = 1; i <= FaceList[0]; i++)
  {
    face = FaceList[i];

    for (j = 1; j <= Geo.FaceVerQty[face]; j++)
    {
      ver = Geo.FaceVerNb[face][j];
      if (oneDIntEltPos (VerList, 1, VerList[0], ver, 0) == -1)
      {
	VerList[0]++;
	VerList[VerList[0]] = ver;
      }
    }
  }

  return;
}
