/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"Tess2Geo.h"

/* UpdateEdgeLength updates the length of the edges of vertex new */
void
CalcEdgeLength (struct GEO *pGeo, int edge)
{
  int i;
  int numa, numb;
  double *cooa;
  double *coob;

  cooa = oneDDoubleDAlloc (3);
  coob = oneDDoubleDAlloc (3);

  numa = (*pGeo).EdgeVerNb[edge][0];
  numb = (*pGeo).EdgeVerNb[edge][1];

  for (i = 0; i <= 2; i++)
  {
    cooa[i] = (*pGeo).VerCoo[numa][i];
    coob[i] = (*pGeo).VerCoo[numb][i];
  }

  (*pGeo).EdgeLength[edge] = threeDDoubleDist (cooa, coob, 0);

  oneDDoubleFree (cooa);
  oneDDoubleFree (coob);

  return;
}
