/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "MMeshUtils.h"

void
FoDAddEltNode (int **FoDNodes, int face, struct MESH Mesh, int *ppos,
	       int x, int y, int z, int XEQty, int YEQty, int eltnode)
{
  int eltid, nodeid;

  eltid = EltCoo2Id (x, y, z, XEQty, YEQty);
  nodeid = Mesh.EltNodes[eltid][eltnode];
  (*ppos)++;
  FoDNodes[face][(*ppos)] = nodeid;

  return;
}

void
SearchFoDNodes_cube (struct NODES Nodes, int face, int* FoDNodes)
{
  int i;

  if (face == 1)
  {
    for (i = 1; i <= Nodes.NodeQty; i++)
      if (Nodes.NodesCoo[i][0] < 1e-12)
	FoDNodes[++FoDNodes[0]] = i;
  }
  else if (face == 2)
  {
    for (i = 1; i <= Nodes.NodeQty; i++)
      if (Nodes.NodesCoo[i][0] > 1 - 1e-12)
	FoDNodes[++FoDNodes[0]] = i;
  }
  else if (face == 3)
  {
    for (i = 1; i <= Nodes.NodeQty; i++)
      if (Nodes.NodesCoo[i][1] < 1e-12)
	FoDNodes[++FoDNodes[0]] = i;
  }
  else if (face == 4)
  {
    for (i = 1; i <= Nodes.NodeQty; i++)
      if (Nodes.NodesCoo[i][1] > 1 - 1e-12)
	FoDNodes[++FoDNodes[0]] = i;
  }
  else if (face == 5)
  {
    for (i = 1; i <= Nodes.NodeQty; i++)
      if (Nodes.NodesCoo[i][2] < 1e-12)
	FoDNodes[++FoDNodes[0]] = i;
  }
  else if (face == 6)
  {
    for (i = 1; i <= Nodes.NodeQty; i++)
      if (Nodes.NodesCoo[i][2] > 1 - 1e-12)
	FoDNodes[++FoDNodes[0]] = i;
  }
  else
    abort();

  return;
}

/*
int GetNodeFromElt(struct MESH Mesh,int x,int y,int z,int size,int pos)
{
    int neltid;

    neltid=EltCoo2Id(x,y,z,XEQty,YEQty);

    return Mesh.EltNodes[neltid][pos];
}
*/

int
EltCoo2Id (int X, int Y, int Z, int XEQty, int YEQty)
{
  return (Z - 1) * YEQty * XEQty + (Y - 1) * XEQty + X;
}

int
PointElt (double *Coo, int msize)
{
  int i, elt;
  int *EltPos = oneDDoubleDAlloc_int (3);

  for (i = 0; i <= 2; i++)
    if (Coo[i] < 0 || Coo[i] > 1)
      return -1;

  printf ("coo: %f %f %f\n", Coo[0], Coo[1], Coo[2]);
  for (i = 0; i <= 2; i++)
    EltPos[i] = ceil (Coo[i] * (double) msize);

  elt = EltCoo2Id (EltPos[0], EltPos[1], EltPos[2], msize, msize);

  oneDIntFree (EltPos);

  return elt;
}
