/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"FaceNodes.h"

int *
ThisFaceNodes (struct MESH Mesh2D, int face)
{
  int i, j, elt;
  int NodesPerElt = 3 * Mesh2D.EltOrder;
  int faceinv = Mesh2D.ElsetNbInv[face];
  int *data =
    oneDDoubleDAlloc_int (Mesh2D.Elsets[faceinv][0] * NodesPerElt + 1);

  for (i = 1; i <= Mesh2D.Elsets[faceinv][0]; i++)
  {
    elt = Mesh2D.Elsets[faceinv][i];
    for (j = 0; j <= NodesPerElt - 1; j++)
    {
      data[0]++;
      data[data[0]] = Mesh2D.EltNodes[elt][j];
    }
  }

  gsl_sort_int (data + 1, 1, data[0]);
  data[0] = oneDIntCompress (data, 1, data[0]);

  return data;
}
