/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"Flatness.h"

double
ThisFaceFF (struct NODES Nodes, struct MESH Mesh2D, int face, int type)
{
  int i, j;
  int elt1, elt2;
  double angle, lff = 0, gff = 0;
  int elsetpos;
  double **FaceEltN;

  elsetpos = Mesh2D.ElsetNbInv[face];
  FaceEltN = twoDDoubleDAlloc (Mesh2D.Elsets[elsetpos][0] + 1, 3);

  if (verbosity >= 1)
    ut_print_message (-1, "Performing IniFaceEltN\n");
  IniFaceEltN (Nodes, Mesh2D, face, FaceEltN);
  if (verbosity >= 1)
    ut_print_message (-1, "Performed  IniFaceEltN\n");

  for (i = 1; i <= Mesh2D.Elsets[elsetpos][0]; i++)
  {
    elt1 = Mesh2D.Elsets[elsetpos][i];

    for (j = i + 1; j <= Mesh2D.Elsets[elsetpos][0]; j++)
    {
      elt2 = Mesh2D.Elsets[elsetpos][j];

      angle = VectorAngle (FaceEltN[i], FaceEltN[j], 0, 1);

      gff = DoubleMax (angle, gff);

      if (NeighElts (Mesh2D, elt1, elt2) == 1)
	lff = DoubleMax (angle, lff);
    }
  }

  twoDDoubleFree (FaceEltN, Mesh2D.Elsets[elsetpos][0] + 1);

  if (type == 0)
    return lff;
  else if (type == 1)
    return gff;
  else
    abort ();
}
