/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"Flatness.h"

void
CalcEltN (struct NODES Nodes, struct MESH Mesh2D, int elt, double *ThisEltN)
{
  int i, eltpos;
  int n1, n2, n3, n1inv, n2inv, n3inv;
  double *a = oneDDoubleDAlloc (3);
  double *b = oneDDoubleDAlloc (3);
  double norm;

  eltpos = Mesh2D.EltNbInv[elt];

  n1 = Mesh2D.EltNodes[eltpos][0];
  n1inv = Nodes.NodesNbInv[n1];
  n2 = Mesh2D.EltNodes[eltpos][1];
  n2inv = Nodes.NodesNbInv[n2];
  n3 = Mesh2D.EltNodes[eltpos][2];
  n3inv = Nodes.NodesNbInv[n3];

  for (i = 0; i <= 2; i++)
  {
    a[i] = Nodes.NodesCoo[n1inv][i] - Nodes.NodesCoo[n2inv][i];
    b[i] = Nodes.NodesCoo[n2inv][i] - Nodes.NodesCoo[n3inv][i];
  }

  VectorVectProd (a, b, ThisEltN, 0);
  norm = VectorNorm (ThisEltN, 0);
  oneDDoubleScale (ThisEltN, 0, 2, 1 / norm);

  oneDDoubleFree (a);
  oneDDoubleFree (b);

  return;
}
