/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"FreeMsh.h"

void
FreeNodes (struct NODES *pNodes)
{
  if (verbosity >= 3)
    ut_print_message (0, "freeing NodesNb\n");
  oneDIntFree ((*pNodes).NodesNb);
  if (verbosity >= 3)
    ut_print_message (0, "freed   NodesNb\n");
  if (verbosity >= 3)
    ut_print_message (0, "freeing NodesNbInv\n");
  oneDIntFree ((*pNodes).NodesNbInv);
  if (verbosity >= 3)
    ut_print_message (0, "freed   NodesNbInv\n");
  if (verbosity >= 3)
    ut_print_message (0, "freeing NodesCoo\n");
  twoDDoubleFree ((*pNodes).NodesCoo, (*pNodes).NodeQty + 1);
  if (verbosity >= 3)
    ut_print_message (0, "freed   NodesCoo\n");

  return;
}

void
FreeMesh (struct MESH *pMesh)
{
  if (verbosity >= 3)
    ut_print_message (0, "freeing EltNb\n");
  oneDIntFree ((*pMesh).EltNb);
  if (verbosity >= 3)
    ut_print_message (0, "freeing EltNb\n");
  if (verbosity >= 3)
    ut_print_message (0, "freeing EltNbInv\n");
  oneDIntFree ((*pMesh).EltNbInv);
  if (verbosity >= 3)
    ut_print_message (0, "freeing EltNbInv\n");
  if (verbosity >= 3)
    ut_print_message (0, "freeing EltNodes\n");
  twoDIntFree ((*pMesh).EltNodes, (*pMesh).EltQty4Alloc + 1);
  if (verbosity >= 3)
    ut_print_message (0, "freeing EltNodes\n");
  if (verbosity >= 3)
    ut_print_message (0, "freeing Elsets\n");
  oneDIntFree ((*pMesh).ElsetNb);
  oneDIntFree ((*pMesh).ElsetNbInv);
  twoDIntFree ((*pMesh).Elsets, (*pMesh).ElsetQty + 1);
  if (verbosity >= 3)
    ut_print_message (0, "freeing Elsets\n");

  return;
}
