/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"ReadMsh.h"

void
ReadMsh (struct NODES *pNodes, struct MESH *pMesh0D, struct MESH *pMesh1D,
	 struct MESH *pMesh2D, struct MESH *pMesh3D, FILE * msh)
{
  ReadMshHead (msh);

  ReadNodes (pNodes, msh);

  ReadElts (pMesh0D, pMesh1D, pMesh2D, pMesh3D, msh);

  return;
}

void
Check3DMesh (struct MESH Mesh3D)
{
  int i;

  for (i = 1; i <= Mesh3D.ElsetQty; i++)
    if (Mesh3D.ElsetNb[i] != i)
    {
      LineHeader (2);
      printf ("Meshing of Polyhedron %d failed!\n", i);
      LineHeader (2);
      printf ("(Volume %d has no element.)\n", i);
      abort ();
    }

  return;
}
