/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "TessImport.h"

/* Tessellation importation: head  */
void
TIHead (FILE * file)
{
  if (CharScanNComp ("***tess1.4", file) != 0)
  {
    ut_print_message (2, "Input file is not a tess1.4 file.\n");
    abort ();
  }

  return;
}

/* Tessellation importation: vertices
 */
void
TIVer (struct TESS *pTess, FILE * file)
{
  TIVerHead (file);
  TIVerQty (pTess, file);
  TIVerProp (pTess, file);

  return;
}

/* Tessellation importation: edges
 */
void
TIEdge (struct TESS *pTess, FILE * file)
{
  TIEdgeHead (file);
  TIEdgeQty (pTess, file);
  TIEdgeProp (pTess, file);

  return;
}

/* Tessellation importation: faces
 */
void
TIFace (struct TESS *pTess, FILE * file)
{
  TIFaceHead (file);
  TIFaceQty (pTess, file);
  TIFaceProp (pTess, file);

  return;
}

/* Tessellation importation: poly
 */
void
TIPoly (struct TESS *pTess, FILE * file)
{
  TIPolyHead (file);
  TIPolyQty (pTess, file);
  TIPolyProp (pTess, file);

  return;
}

/* Tessellation importation: domain
 */
void
TIDomain (struct TESS *pTess, FILE * file)
{
  int i;

  TIDomainHead (file);

  (*pTess).VerOfDomain = oneDDoubleDAlloc_int (8);

  for (i = 0; i <= 7; i++)
    fscanf (file, "%d", &(*pTess).VerOfDomain[i]);

  return;
}

/* Tessellation importation: foot
 */
void
TIFoot (FILE * file)
{
  if (CharScanNComp ("***end", file) != 0)
    abort ();

  return;
}
