/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"FaceFF.h"

void
FaceFFMeshGeo (struct GEO *pGeo, struct GEOPARA GeoPara, int *FaceList)
{
  int i, j, edge;
  int face;

  FILE *file;

  int * VerList = ut_alloc_1d_int (1000);
  int * EdgeList = ut_alloc_1d_int (1000);

  /* Recording the faces into FaceList
   * printf("Recording faces\n");
   */

  /* Recording the edges and vertices into EdgeList and VerList
   * printf("Recording edges and vers\n");
   */
  for (i = 1; i <= FaceList[0]; i++)
    {
      face = FaceList[i];

      for (j = 1; j <= (*pGeo).FaceVerQty[face]; j++)
	{
	  edge = (*pGeo).FaceEdgeNb[face][j];
	  EdgeMeshing (pGeo, edge, GeoPara.cl, GeoPara.pcl);
	}

      for (j = 1; j <= (*pGeo).FaceVerQty[face]; j++)
	{
	  EdgeList[0]++;
	  EdgeList[EdgeList[0]] = (*pGeo).FaceEdgeNb[face][j];

	  VerList[0]++;
	  VerList[VerList[0]] = (*pGeo).FaceVerNb[face][j];
	}
    }
  /*printf("Recorded  edges and vers\n"); */
  oneDIntSort (EdgeList, 1, EdgeList[0]);
  EdgeList[0] = oneDIntCompress (EdgeList, 1, EdgeList[0]);

  oneDIntSort (VerList, 1, VerList[0]);
  VerList[0] = oneDIntCompress (VerList, 1, VerList[0]);

  file = fopen ("tmp.geo", "w");

  WriteMeshingOptions (file);

  for (i = 1; i <= VerList[0]; i++)
    WriteThisVer (*pGeo, VerList[i], file, 0);

  for (i = 1; i <= EdgeList[0]; i++)
    if ((*pGeo).EdgeNodeQty[EdgeList[i]] == 0)
      WriteThisEdge (*pGeo, EdgeList[i], file, 0);
    else
      WriteThisDiscreteEdge (*pGeo, EdgeList[i], file);

  for (i = 1; i <= FaceList[0]; i++)
    WriteThisFace (*pGeo, FaceList[i], file, 1);

  fclose (file);

  oneDIntFree (VerList);
  oneDIntFree (EdgeList);

  return;
}
