/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"WriteGeo.h"

/* Writing of the geo file */
void
WriteGeo (struct GEO Geo, struct GEOPARA GeoPara, struct IN In,
	  int argc, char **argv, char *Version)
{
  FILE *file = OpenFile (In.geo, "w");

  if (In.verbosity > 1)
    ut_print_message (0, "  Writing information.\n");
  WriteGeoInfo (argc, argv, Version, file);

  WriteMeshingOptions (file);

  if (In.meshimprovement2d == 0)
  {
    WriteMeanCL (GeoPara, file);
    WriteGeoVer (Geo, GeoPara, file);
    WriteGeoEdge (Geo, In, file);
  }

  WriteGeoFace (Geo, file);
  WriteGeoPoly (Geo, file);

  CloseFile (file, In.geo, "w");

  return;
}

void
WriteThisFaceWAllEntities (struct GEO *pGeo, int face, FILE * file)
{
  int i;
  int edge;

  for (i = 1; i <= (*pGeo).FaceVerQty[face]; i++)
    {
      /*printf("writing ver %d/%d\n",i,(*pGeo).FaceVerQty[face]); */
      WriteThisVer (*pGeo, (*pGeo).FaceVerNb[face][i], file, 1);
    }

  for (i = 1; i <= (*pGeo).FaceVerQty[face]; i++)
    {
      edge = (*pGeo).FaceEdgeNb[face][i];

      /*printf("writing edge %d/%d\n",i,(*pGeo).FaceVerQty[face]); */
      if ((*pGeo).EdgeNodeQty[edge] == 0)
	WriteThisEdge (*pGeo, edge, file, 1);
      else
	WriteThisDiscreteEdge (*pGeo, edge, file);
    }

  /*printf("writing face %d\n",face); */
  WriteThisFace (*pGeo, face, file, 1);

  return;
}
