/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"InputData_fm.h"

void
InputData_fm (struct IN *pIn, struct TESS *pTess, struct GEOPARA *pGeoPara,
	      int fargc, char **fargv, int argc, char **argv)
{
  FILE *tess;

  TreatArg_fm (fargc, fargv, argc, argv, pIn, pGeoPara);

  if ((*pIn).mesh == 0 && (*pIn).conv == 0)
    {
      tess = OpenFile ((*pIn).tess, "r");
      TessImport (pTess, tess);
      CloseFile (tess, (*pIn).tess, "r");
    }

  /* Calculation of cl */
  if ((*pIn).mesh == 0 && (*pIn).conv == 0 && (*pGeoPara).cl < 0)
    rcl2cl (*pTess, pGeoPara);

  /* Calculation of sacl */
  if ((*pGeoPara).sacl < 0)
    {
      if ((*pGeoPara).sarcl < 0)
	(*pGeoPara).sacl = (*pGeoPara).cl;
      else
	{
	  (*pGeoPara).sacl = (*pGeoPara).sarcl * MeanEdgeLength (*pTess);
	  if ((*pGeoPara).sa < 1e-6)
	    MessageWNC (1, 72,
			"While using option `-sa[r]cl', you should also use option `-sa'. As is, `-sa[r]cl' has no effect ...");
	}
    }

  /* Calculation of sel */
  if ((*pGeoPara).sel < 0)
    {
      if ((*pGeoPara).rsel < 0)
	(*pGeoPara).sel = (*pGeoPara).cl / (*pGeoPara).pcl;
      else
	(*pGeoPara).sel = (*pGeoPara).rsel * MeanEdgeLength (*pTess);
    }

  return;
}
