/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"MStat.h"

void
PrintEStat (struct NODES Nodes, struct MESH Mesh3D, struct IN In)
{
  int i, j;
  FILE *file;
  double *EltVol;
  double *EltRho;
  double **EltAngle;

  /* Calculating element statistics */
  CalcVol (Nodes, Mesh3D, &EltVol);
  CalcRho (Nodes, Mesh3D, &EltRho);
  CalcAngle (Nodes, Mesh3D, &EltAngle);

  /* Printing results */
  file = OpenFile (In.estat, "w");
  for (i = 1; i <= Mesh3D.EltQty; i++)
    fprintf (file, "%d\t%g\t%f\t%f\n", Mesh3D.EltNb[i], EltVol[i], EltRho[i],
	     EltAngle[i][0]);
  CloseFile (file, In.estat, "w");

  file = OpenFile (In.eangle, "w");
  for (i = 1; i <= Mesh3D.EltQty; i++)
    {
      fprintf (file, "%d", Mesh3D.EltNb[i]);
      for (j = 1; j <= 12; j++)
	fprintf (file, " %.2f", EltAngle[i][j]);
      fprintf (file, "\n");
    }
  CloseFile (file, In.eangle, "w");

  /* Freeing memory */
  oneDDoubleFree (EltVol);
  oneDDoubleFree (EltRho);
  twoDDoubleFree (EltAngle, 13);

  return;
}
