/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"Meshing2D.h"

void
GeoMeshing2D (struct GEO *pGeo, struct IN In)
{
  int i;
  int *FaceNodes;

  for (i = 1; i <= (*pGeo).FaceQty; i++)
    {
      /* must the face be discretize?: setting FaceDis */
      if (In.meshimprovement2d == 0)
	FaceTest4Dis (pGeo, i);
      else if ((*pGeo).FaceState[i] >= 0)
	(*pGeo).FaceDis[i] = 1;

      if ((*pGeo).FaceDis[i] == 1)	/* yes */
	{
	  if (verbosity > 0)
	    {
	      printf ("\n\n");
	      LineHeader (0);
	      printf ("Discretizing face %d\n", i);
	    }
	  DiscretizeThisFace (pGeo, In.gmsh, i);

	  if (In.meshimprovement2d == 1 && Test2DMesh (*pGeo, i) == -1)
	    {
	      if (verbosity > 0)
		{
		  LineHeader (0);
		  printf ("face %d: improving mesh ...\n", i);
		}
	      DiscretizeThisFace (pGeo, In.gmsh, i);
	    }

	  if (In.ffalgo != 0)
	    {
	      FaceNodes = GeoFaceNodes (*pGeo, i);
	      InterpolateFaceBody (pGeo, &((*pGeo).FaceNodes[i]), FaceNodes,
				   i);
	      oneDIntFree (FaceNodes);
	    }
	}
    }

  return;
}
