/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"Meshing3D.h"

/* Meshing meshes the geometry if requested and reads the mesh.
 * At the end of Meshing, one gets the mesh and the fods, either
 * from the mesh we just built or a msh file to convert.
 */
void
GeoMeshing3D (struct IN In, struct NODES *pNodes,
	      struct MESH *pMesh2D, struct MESH *pMesh3D)
{
  char *Args = oneDCharDAlloc (1000);
  struct MESH TrashMesh0, TrashMesh1;	/* trash meshes. */
  FILE *msh;

  /*LineHeader(0); printf("Meshing geometry... [%s]\n",In.gmsh); */

  sprintf (Args, "-3 -v 0 %s -order %d -o %s", In.geo, In.morder, In.msh);

  CallGmsh (In.gmsh, Args);

  oneDCharFree (Args);

  /* ut_print_message(0,"Meshed geometry...\n"); */

  /* Reading mesh */
  msh = OpenFile (In.msh, "r");
  ReadMsh (pNodes, &TrashMesh0, &TrashMesh1, pMesh2D, pMesh3D, msh);
  CloseFile (msh, In.msh, "r");
  Check3DMesh (*pMesh3D);

  if (In.printgeo == 0)
    remove (In.geo);

  return;
}
