/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"WriteGeof.h"

void
WriteGeof (struct IN In, struct GEO Geo, struct NODES Nodes,
	   struct MESH Mesh2D, struct MESH Mesh3D)
{
  FILE *geof;
  char command[1000];

  int **FoDNodes;
  int **FoD = oneDpIntDAlloc (7);

  /* searching FoDNodes --- */
  FoD = ReadFoD (In.fod);
  FoDNodes = SearchFoDNodes (Mesh2D, FoD);

  /* searched FoDNodes --- */

  /* Writing geof --- */
  geof = ut_file_open (In.geof, "w");

  /* writing nodes */
  WriteNodes (Nodes, geof);

  /* writing elts */
  WriteElts (Mesh3D, geof);

  fprintf (geof, "***group\n");

  /* writing nsets */
  WriteNSets (In.nset, FoDNodes, geof);	/* will write only if nset>0 */

  /* writing elsets */
  if (In.liset == 1)
    WriteFoDLiset (Geo, FoD, Nodes, Mesh2D, geof);

  WriteElsets (Mesh3D, geof);

  fprintf (geof, "***return\n");

  ut_file_close (geof, In.geof, "w");
  /* Wrote geof --- */

  /* optionally, renaming geo to geob */
  if (In.geo2geob == 1 && FileExists (In.geo))
    {
      sprintf (command, "mv %s %s", In.geo, In.geob);
      system (command);
    }

  twoDIntFree (FoD, 7);
  twoDIntFree (FoDNodes, 7);

  return;
}

/*
void WriteOriInStd(int Random,int N,char* filename)
{
    int i;
    int m=0;
    FILE* file;
    
    file=OpenFile(filename,"w");

    fprintf(file,"%ld %d\n",Random-1,N);

    for(i=1;i<=N;i++)
	FPrintfWNC(file,3*i-2,&m,72);

    CloseFile(file,filename,"w");

    return;
}
*/
