/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#ifndef STRUCTIN_H
#define STRUCTIN_H

struct IN
{
  int verbosity;
  char *gmsh;

  /* FILE NAMES */
  char *tess;			/* tess  file name (input tessellation) */

  /* GENERALITIES ON THE GEO */
  int newver;			/* how to position the new vertices? */
  int edgedis;			/* discretize the edges with neper?  */

  /* FFFS */
  int ffalgo;			/* this is for non-planar faces */
  int mloop;

  /* ADDITIONAL STUFF */
  int delstop;			/* this is for debugging */

  /* MESH */
  int morder;

  char* format;			/* geo (1), msh (2) and/or geof (4) */
  int meshalgorithm;		/* 1: isotropic, 2: anisotropic, 3: triangle */

  int nset;			/* list the nset: none (0), faces (1) */

  /* additional functions */
  int conv;			/* to convert msh to geof */
  int mesh;			/* to mesh from a geo file */

  int geo2geob;

  int meshimprovement2d;

  char *geo;
  int printgeo;			/* geo   file name (output gmsh geo  )  */
  char *geob;
  char *ff;			/* ff    file name (flatness faults  )  */
  char *edgel;
  int printedgel;		/* edgel file name (edge lengths     )  */
  char *angle;
  int printangle;		/* angle file name (geo angles       )  */
  char *msh;
  int printmsh;
  char *geof;
  int printgeof;
  char *estat;
  int printestat;		/* if =1: printing element statistics  */
  char *eangle;
  int printeangle;		/* if =1: printing element angles      */
  char *nstat;
  int printnstat;		/* if =1: printing node statistics  */
  char *fod;
  int printfod;
  int liset;
  char *oin;
  int print;
  int* printfaces;
  char *mast;
  char *asy;
};
typedef struct IN IN;

#endif /* STRUCTIN_H */
