/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"RMeshingFNId.h"

void
RMeshingFNId (struct IN In, struct MAPMESH *pMap, struct DNEIGH *pDNeigh)
{
  (*pDNeigh).Size = ut_alloc_1d (7);
  (*pDNeigh).Size[1] = (*pDNeigh).Size[3] = (*pDNeigh).Size[5] = 0;
  (*pDNeigh).Size[2] = (*pDNeigh).Size[4] = (*pDNeigh).Size[6] = 1;
  (*pDNeigh).Vol = 1;

  /* Setting germs coo */
  (*pDNeigh).Random = NnId2Rand ((*pDNeigh).NDensity, (*pDNeigh).Id);

  /* N */
  if ((*pDNeigh).ttype == 0 || (*pDNeigh).ttype == 1)
    (*pDNeigh).N = (*pDNeigh).NDensity;
  else if ((*pDNeigh).ttype == 2)
    (*pDNeigh).N =
      PoissonNb ((*pDNeigh).NDensity, (int) (*pDNeigh).Random, 1);
  else
    abort ();

  /* GermsCoo
   * inside the domain
   */
  (*pDNeigh).GermsCoo = ut_alloc_2d ((*pDNeigh).N + 1, 4);
  IniGermsCoo ((*pDNeigh).N, (*pDNeigh).Random,
	       In.ps2d, (*pDNeigh).Size, (*pDNeigh).GermsCoo);

  DefDNeigh (pDNeigh);

  /* Searching elt poly */
  NIdSearchEltPoly (In, pDNeigh, pMap);

  return;
}
