/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "Res_mm.h"

void
WriteMapMesh (struct MMDEF MMDef, struct MAPMESH Map, int **pPolyEltQty)
{
  char command[1000];
  char *filename;
  int i, elset, PrintedElset, col;
  int EltQty = Map.MeshSize[0] * Map.MeshSize[1] * Map.MeshSize[2];

  FILE *file;

  if (MMDef.mesh == 2)		/* copying load mesh to the result geof file. */
    {
      sprintf (command, "grep -v ***return %s > %s", MMDef.loadmesh,
	       MMDef.geof);
      system (command);
    }

  if (MMDef.mesh == 0)		/* res = relset file */
    filename = MMDef.relset;
  else
    filename = MMDef.geof;	/* res = geof file */

  if (MMDef.mesh == 0)
    file = OpenFile (filename, "w");
  else
    file = OpenFile (filename, "a");

  elset = 0;
  PrintedElset = 0;
  col = 1;
  for (i = 1; i <= EltQty; i++)
    {
      if (gsl_vector_int_get (Map.EltPoly, Map.EltId[i]) != elset)
	{
	  elset = gsl_vector_int_get (Map.EltPoly, Map.EltId[i]);
	  PrintedElset++;
	  fprintf (file, "\n**elset poly%d\n", PrintedElset);
	  col = 0;
	  (*pPolyEltQty)[0]++;
	}

      (*pPolyEltQty)[elset]++;

      FPrintfWNC (file, Map.EltId[i], &col, 72);
    }
  fprintf (file, "\n");

  if (MMDef.mesh != 0)
    fprintf (file, "\n***return\n");

  CloseFile (file, filename, "w");

  return;
}

void
WriteOriIn (struct DNEIGH DNeigh, int *PolyEltQty)
{
  int i;
  int m = 0;
  FILE *file;

  file = OpenFile (DNeigh.oin, "w");

  fprintf (file, "%ld %d\n", DNeigh.Random - 1, PolyEltQty[0]);

  for (i = 1; i <= DNeigh.N; i++)
    if (PolyEltQty[i] != 0)	/* printing the ori rng id only */
      FPrintfWNC (file, 3 * i - 2, &m, 72);	/* if the poly has got elements. */
  for (i = 1; i <= DNeigh.nN; i++)	/* else, it must not be printed. */
    if (PolyEltQty[i + DNeigh.N] != 0)	/* the same... */
      FPrintfWNC (file, DNeigh.nGermRandId[i], &m, 72);

  CloseFile (file, DNeigh.oin, "w");

  return;
}


