/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"CalcOri.h"
#define PI 3.14159265358979323844

void
CalcOri (struct ORI *pOri)
{
  int i;
  gsl_rng *r;
  double trash;
  FILE *file;
  int nextrngid;

  if ((*pOri).N != 0)
    {
      (*pOri).Random = NnId2Rand ((*pOri).N, (*pOri).id) - 1;
      /* "-1" is absolutely necessary! */
      /* This is to avoid correllation bw the germ positions (module -T or -MM) */
      /* and the germs orientations: we take a different rng seed ('Random' value). */

      (*pOri).rngid = ut_alloc_1d_int ((*pOri).N + 1);
      for (i = 1; i <= (*pOri).N; i++)
	(*pOri).rngid[i] = 1 + 3 * (i - 1);
    }
  else
    {
      file = OpenFile ((*pOri).oin, "r");
      fscanf (file, "%d", &(*pOri).Random);
      fscanf (file, "%d", &(*pOri).N);
      (*pOri).rngid = ut_alloc_1d_int ((*pOri).N + 1);
      for (i = 1; i <= (*pOri).N; i++)
	fscanf (file, "%d", &(*pOri).rngid[i]);
    }

  /* allocating angle */
  (*pOri).angle = ut_alloc_2d ((*pOri).N + 1, 3);

  r = gsl_rng_alloc (gsl_rng_ranlxd2);
  gsl_rng_set (r, (*pOri).Random);

  nextrngid = 1;
  for (i = 1; i <= (*pOri).N; i++)
    {
      if (nextrngid > (*pOri).rngid[i])
	{
	  MessageWNC (2, 72, "Bad input data!");
	  abort ();
	}

      while (nextrngid < (*pOri).rngid[i])	/* skipping if necessary */
	{
	  trash = gsl_rng_uniform (r);
	  nextrngid++;
	}

      (*pOri).angle[i][0] = 360 * gsl_rng_uniform (r);
      (*pOri).angle[i][1] = (180 / PI) * acos (2 * gsl_rng_uniform (r) - 1);
      (*pOri).angle[i][2] = 360 * gsl_rng_uniform (r);
      nextrngid += 3;
    }

  gsl_rng_free (r);

  return;
}
