/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"InputData_o.h"

void
TreatArg_o (int fargc, char **fargv, int argc, char **argv,
	    struct ORI *pOri, struct RESDATA *pResData)
{
  char *body;
  int inibody = 0;

  int iniN = 0;			/* 1 if N is initialized. */
  int inioin = 0;		/* 1 if oin is initialized. */

  SetDefaultOptions_o (pOri, pResData);

  /* Reading options */
  SetOptions_o (pOri, pResData, &body, &inibody, &iniN, &inioin, fargc,
		fargv);
  SetOptions_o (pOri, pResData, &body, &inibody, &iniN, &inioin, argc, argv);

  /* Testing options */
  if ((iniN == 0 && inioin == 0) || (iniN == 1 && inioin == 1))
    BadArguments ();

  /* Writing file names */

  if (inibody == 0)
    {
      body = oneDCharDAlloc (1000);

      if ((iniN == 1) && ((*pOri).id != -1))
	sprintf (body, "n%d-id%d", (*pOri).N, (*pOri).id);
      else if ((iniN == 1) && ((*pOri).id == -1))
	sprintf (body, "n%d-rand", (*pOri).N);
      else
	body = GiveBody ((*pOri).oin);
    }

  (*pResData).ori = AddExtension (body, ".ori");

  if (inibody == 0)
    oneDCharFree (body);

  return;
}
