/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"InputData_o.h"

/* SetDefaultOptions set the options to their default values */
void
SetDefaultOptions_o (struct ORI *pOri, struct RESDATA *pResData)
{
  (*pOri).N = 0;
  (*pOri).id = -1;

  (*pOri).oin = NULL;
  (*pOri).rngid = NULL;

  (*pResData).ori = NULL;
  (*pResData).verbosity = 0;

  return;
}

void
SetOptions_o (struct ORI *pOri, struct RESDATA *pResData, char **pbody,
	      int *pinibody, int *piniN, int *pinioin, int argc, char **argv)
{
  int i, ArgQty, Res;
  char **ArgList = twoDCharDAlloc (101, 101);
  char *Arg = oneDCharDAlloc (101);

  /* This is the possible argument list. */
  ArgQty = 4;
  sprintf (ArgList[1], "-o");
  sprintf (ArgList[2], "-n");
  sprintf (ArgList[3], "-id");
  sprintf (ArgList[4], "-v");

  for (i = 1; i <= argc - 1; i++)
    {
      if (argv[i][0] != '-')
	{
	  if ((*pinioin) == 0)
	    {
	      (*pOri).oin = oneDCharDAlloc (strlen (argv[i]));
	      (*pOri).oin = argv[i];
	      (*pinioin) = 1;
	    }
	  else
	    BadArguments ();
	}
      else
	{
	  /* Searching option name (string completion stuff) */
	  Res = StringComp (argv[i], ArgList, ArgQty, Arg);
	  if (Res == 1)
	    {
	      LineHeader (2);
	      printf ("Several possibilities for option `%s'.\n", argv[i]);
	      BadArguments ();
	    }
	  else if (Res == -1)
	    {
	      LineHeader (2);
	      printf ("Unknown option `%s'.\n", argv[i]);
	      BadArguments ();
	    }

	  if (strcmp (Arg, "-o") == 0 && i < argc - 1)
	    {
	      (*pbody) = NextArgAsChar (argv, &i, Arg);
	      (*pbody) = GiveBody ((*pbody));
	      (*pinibody) = 1;
	    }
	  else if (strcmp (Arg, "-n") == 0 && i < argc - 1)
	    {
	      (*pOri).N = NextArgAsInt (argv, &i, Arg, 1, 1e7);
	      (*piniN) = 1;
	    }
	  else if (strcmp (Arg, "-id") == 0 && i < argc - 1)
	    (*pOri).id = NextArgAsInt (argv, &i, Arg, 1, 1e7);
	  else if (strcmp (Arg, "-v") == 0 && i < argc - 1)
	    (*pResData).verbosity = NextArgAsInt (argv, &i, Arg, 0, 1);
	  else
	    {
	      BadArguments ();
	      exit (0);
	    }
	}
    }

  twoDCharFree (ArgList, 101);
  oneDCharFree (Arg);

  return;
}
