/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"InputData_t.h"

void
TreatArg_t (int fargc, char **fargv, int argc, char **argv,
	    struct IN *pIn, struct GERMSET *pGermSet)
{
  char *body;
  int inibody = 0;

  SetDefaultOptions_t (pIn, pGermSet);

  /* Reading options */
  SetOptions_t (pIn, pGermSet, &body, &inibody, fargc, fargv);
  SetOptions_t (pIn, pGermSet, &body, &inibody, argc, argv);

  /* Testing options */
  if ((*pIn).input == -1)
  {
    ut_print_message (2, "missing input data.");
    abort ();
  }

  if ((*pIn).input == 1 && (*pGermSet).Id == -1)
    MessageWNC (1, 72,
		"The identifier (-id) has not been specified; considering a random value...");

  /* Writing file names */


  if ((*pIn).input == 0)
  {
    body = ut_alloc_1d_char (1000);
    body = ut_string_body ((*pIn).tess);
  }
  else if (inibody == 0)
  {
    body = ut_alloc_1d_char (1000);

    if ((*pGermSet).Id != -1)
      sprintf (body, "n%d-id%d", (*pGermSet).N, (*pGermSet).Id);
    else
      sprintf (body, "n%d-rand", (*pGermSet).N);

    (*pIn).tess = AddExtension (body, ".tess");
  }

  (*pIn).vcoo = AddExtension (body, ".vcoo");
  (*pIn).mast = AddExtension (body, "-print.mast");
  (*pIn).asy = AddExtension (body, "-print.asy");
  
  if ((*pIn).printpointpoly == 1)
    (*pIn).polyid = AddExtension ((*pIn).point, ".polyid");
  else if ((*pIn).printpointpoly == 2)
    (*pIn).polyid = AddExtension ((*pIn).point, "-centre.polyid");
  
  if (inibody == 0 || (*pIn).input == 0)
    ut_free_1d_char (body);

  return;
}
