/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include"PolyAlloc.h"

/* PolymodAlloc: The memory associated to the several 1-D or 2-D boards
 * that intervene in the Polymod structure definition is allocated.
 * This uses the internal parameters and is independent of the
 * morphology of the initial polyhedron (cubic or not).
 */
void
PolymodAlloc (struct INTEPARA IntePara, struct POLYMOD *pPolymod)
{
  (*pPolymod).VerFace = ut_alloc_2d_int (IntePara.MaxPolyVerQty + 1, 3);
  (*pPolymod).VerCoo = ut_alloc_2d (IntePara.MaxPolyVerQty + 1, 3);
  (*pPolymod).VerUse = ut_alloc_1d_int (IntePara.MaxPolyVerQty + 1);
  (*pPolymod).FaceEq = ut_alloc_2d (IntePara.MaxPolyFaceQty + 1, 4);
  (*pPolymod).FaceGerm = ut_alloc_1d_int (IntePara.MaxPolyFaceQty + 1);
  (*pPolymod).FaceVerQty = ut_alloc_1d_int (IntePara.MaxPolyFaceQty + 1);
  (*pPolymod).FaceVerNb =
    ut_alloc_2d_int (IntePara.MaxPolyFaceQty + 1, IntePara.MaxPolyFaceQty + 1);
  (*pPolymod).FaceUse = ut_alloc_1d_int (IntePara.MaxPolyFaceQty + 1);

  return;
}
