/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "PointPoly.h"

void
PrintPointPoly (struct IN In, struct TESS Tess)
{
  int i, j, id;
  int qty = 0;
  FILE* file;
  struct TESS Tess2;
  double** points;

  /* recording points */
  if (In.printpointpoly == 1)
  {
    qty = ut_num_d2ri (ut_file_nbwords (In.point) / 3.);
    points = ut_alloc_2d (qty, 3);

    file = ut_file_open (In.point, "r");
    ut_board_2d_fscanf (file, points, qty, 3);
    ut_file_close (file, In.point, "r");
  }
  else if (In.printpointpoly == 2)
  {
    file = ut_file_open (In.point, "r");
    TessImport (&Tess2, file);

    qty = Tess2.PolyQty;
    points = ut_alloc_2d (Tess2.PolyQty, 3);
    for (i = 0; i < Tess2.PolyQty; i++)
      for (j = 0; j < 3; j++)
	points[i][j] = Tess2.CenterCoo[i+1][j];

    ut_file_close (file, In.point, "r");
  }
  else
    return;

  ut_print_message (0, "Printing point polyhedron identifiers...\n");
  /* searching point poly id */
  file = ut_file_open (In.polyid, "w");
    
  for (i = 0; i < qty; i++)
  {
    for (j = 1; j <= Tess.PolyQty; j++)
    {
      id = 0;
      if (InPoly (points[i] - 1, Tess, j) == 1)
      {
	id = j;
	break;
      }
    }

    fprintf (file, "%d\n", id);
  }
  
  ut_file_close (file, In.polyid, "w");
  ut_print_message (0, "Printed point polyhedron identifiers.\n");

  return;
}
