/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "Res_t.h"

extern void
Res_t (struct IN In, struct TESS Tess)
{
  FILE *ExportFile;
  struct GEO Geo;

  ExportFile = OpenFile (In.tess, "w");
  TessExport (Tess, ExportFile);
  CloseFile (ExportFile, In.tess, "w");

  if (In.vcoocalc == 1)
  {
    ExportFile = OpenFile (In.vcoo, "w");
    VerCoo (Tess, ExportFile);
    CloseFile (ExportFile, In.vcoo, "w");
  }

  if (In.print > 0)
  {
    Tess2Geo (Tess, &Geo);
    PrintGeoAsAsy (In.print, In.printfaces, Geo, In.asy);
    PrintGeoAsMast (In.print, In.printfaces, Geo, In.mast);
  }

  if (In.printpointpoly)
    PrintPointPoly (In, Tess);

  return;
}
