/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */

#include "VerCoo.h"

void
VerCoo (struct TESS Tess, FILE * out)
{
  int i;
  int vertype;

  int *TruePoly = ut_alloc_1d_int (Tess.PolyQty + 1);
  int *TrueVer = ut_alloc_1d_int (Tess.VerQty + 1);

  /* Searching true polyhedra and true vertices */
  SearchTruePoly (Tess, &TruePoly);
  SearchTrueVer (Tess, TruePoly, &TrueVer);

  /* Printing results */
  for (vertype = 0; vertype <= 4; vertype++)
    for (i = 1; i <= Tess.VerQty; i++)
      if (TrueVer[i] == vertype)
	fprintf (out, "%d %d %.15f %.15f %.15f\n", i, TrueVer[i],
		 Tess.VerCoo[i][0], Tess.VerCoo[i][1], Tess.VerCoo[i][2]);

  /* Freeing memory */
  oneDIntFree (TruePoly);
  oneDIntFree (TrueVer);

  return;
}
