/* This file is part of the 'neper' program. */
/* Copyright (C) 2004-2009, Romain Quey. */
/* See the COPYING file in the top-level directory. */
 
#include"ut_file.h"

extern int
ut_file_nblines (char *filename)
{
  int nblines;
  FILE *file;
  char trash[10000];

  file = fopen (filename, "r");

  nblines = 0;
  while (fgets (trash, 1000, file))
    nblines++;

  fclose (file);

  return nblines;
}

extern int
ut_file_nblines_pointer (FILE * file)
{
  int nblines;
  char trash[10000];

  nblines = 0;
  while (fgets (trash, 1000, file))
    nblines++;

  fseek (file, 0, 0);

  return nblines;
}

extern int
ut_file_nbwords (char *filename)
{
  int nbwords;
  FILE *file;
  char trash[10000];

  file = fopen (filename, "r");

  nbwords = 0;
  while (fscanf (file, "%s", trash) == 1)
    nbwords++;

  fclose (file);

  return nbwords;
}

extern int
ut_file_nbwords_pointer (FILE * file)
{
  int nbwords;
  char trash[10000];

  nbwords = 0;
  while (fscanf (file, "%s", trash) == 1)
    nbwords++;

  fseek (file, 0, 0);

  return nbwords;
}

int
ut_file_exist (char *name)
{
  if (fopen (name, "r") == NULL)
    return 0;
  else
    return 1;
}

FILE *
ut_file_open (char *name, char *mode)
{
  FILE *file;

  ut_file_openmessage (name, mode);

  if (mode[0] == 'r' || mode[0] == 'R')
    file = fopen (name, "r");
  else if (mode[0] == 'w' || mode[0] == 'W')
    file = fopen (name, "w");
  else if (mode[0] == 'a' || mode[0] == 'A')
    file = fopen (name, "a");
  else
    abort ();

  return file;
}

void
ut_file_openmessage (char *name, char *mode)
{
  if (mode[0] == 'r')
  {
    ut_print_lineheader (0);
    printf ("Parsing file `%s' ...\n", name);
  }
  else if (mode[0] == 'w')
  {
    ut_print_lineheader (0);
    printf ("Writing file `%s' ...\n", name);
  }
  else if (mode[0] == 'a')
  {
    ut_print_lineheader (0);
    printf ("Writing file `%s' ...\n", name);
  }

  return;
}


void
ut_file_close (FILE * file, char *name, char *mode)
{
  ut_file_closemessage (name, mode);

  fclose (file);
  file = NULL;

  return;
}

void
ut_file_closemessage (char *name, char *mode)
{
  if (mode[0] == 'r')
  {
    ut_print_lineheader (0);
    printf ("Parsed file `%s'.\n", name);
  }
  else if (mode[0] == 'w')
  {
    ut_print_lineheader (0);
    printf ("Wrote file `%s'.\n", name);
  }

  return;
}

void
ut_file_trash (FILE * file, int qty)
{
  int i;
  char trash[1000];

  for (i = 0; i < qty; i++)
    fscanf (file, "%s", trash);

  return;
}

void
ut_file_tofile (FILE * in, int qty, FILE * out, char *a, char *b)
{
  int i;
  char s[1000];

  for (i = 0; i < qty; i++)
  {
    fscanf (in, "%s", s);
    fprintf (out, "%s%s", s, a);
  }
  fprintf (out, "%s", b);

  return;
}


double
ut_file_readwcomma (FILE * file)
{
  char *tmp = ut_alloc_1d_char (100);
  double res;

  fscanf (file, "%s", tmp);
  res = ut_num_readwcomma (tmp);

  ut_free_1d_char (tmp);

  return res;
}
